###############################################################################
###############################################################################
##
##  Copyright (C) 2004-2005 Red Hat, Inc.  All rights reserved.
##
##  This copyrighted material is made available to anyone wishing to use,
##  modify, copy, or redistribute it subject to the terms and conditions
##  of the GNU General Public License v.2.
##
###############################################################################
###############################################################################
%define buildup 1
%define buildsmp 1
%define buildxen 0
%define kernel_version 2.6.15-1.1833_FC4
%define subversion 20050420.133124.FC4

%ifnarch i686 x86_64
%define buildsmp 0
%endif 

%ifnarch i686
%define buildxen 0
%endif

Name: gnbd-kernel
Version: 2.6.11.2
Release: %{subversion}.58
License: GPL
Group: System Environment/Kernel
Summary: gnbd-kernel - The kernel module for GFS's Network Block Device
BuildRequires: kernel = %{kernel_version}
BuildRequires: kernel-smp = %{kernel_version}
BuildRequires: kernel-devel = %{kernel_version}
BuildRequires: kernel-smp-devel = %{kernel_version}
Conflicts: GFS <= 6.0
Conflicts: GFS-modules
Requires: kernel = %{kernel_version}
Requires: /lib/modules/%{kernel_version}
Provides: gnbd-kernel-modules = %{version}-%{release}
Provides: kernel-modules
ExclusiveArch: i586 i686 x86_64 ppc ppc64
Source0: %{name}-%{version}-%{subversion}.tar.gz
BuildRoot: %{_tmppath}/%{name}-%{version}-%{release}-buildroot

%description
gnbd-kernel - The kernel module for GFS's Network Block Device

%package -n gnbd-kernheaders
Group: Development/System
Summary: gnbd kernel header files

%description -n gnbd-kernheaders
The gnbd kernel headers are used to compile the gnbd userland tools.

%if %{buildsmp}
%package -n gnbd-kernel-smp
Group: System Environment/Kernel
Summary: gnbd-kernel-smp - The kernel module for GFS's Network Block Device
Requires: kernel-smp = %{kernel_version}
Requires: /lib/modules/%{kernel_version}smp
Provides: gnbd-kernel-modules = %{version}-%{release}
Provides: kernel-modules

%description -n gnbd-kernel-smp
gnbd-kernel-smp - The smp kernel module for GFS's Network Block Device
%endif

%if %{buildxen}
%package -n gnbd-kernel-xenU
Group: System Environment/Kernel
Summary: gnbd-kernel-xenU - The kernel module for GFS's Network Block Device
Requires: kernel-xenU = %{kernel_version}
Requires: /lib/modules/%{kernel_version}xenU
Provides: gnbd-kernel-modules = %{version}-%{release}
Provides: kernel-modules

%description -n gnbd-kernel-xenU
gnbd-kernel-smp - The smp kernel module for GFS's Network Block Device

%package -n gnbd-kernel-xen0
Group: System Environment/Kernel
Summary: gnbd-kernel-xen0 - The kernel module for GFS's Network Block Device
Requires: kernel-xen0 = %{kernel_version}
Requires: /lib/modules/%{kernel_version}xen0
Provides: kernel-modules
Provides: gnbd-kernel-modules = %{version}-%{release}

%description -n gnbd-kernel-xen0
gnbd-kernel-smp - The smp kernel module for GFS's Network Block Device

%endif
################################################################################
##  THE PREP SECTION
################################################################################
%prep
%setup -q -n %{name}-%{version}-%{subversion}

################################################################################
##  THE BUILD SECTION
################################################################################
%build
BUILD_TOPDIR=`pwd`

cp -r `pwd` ../smp
cp -r `pwd` ../xenU
cp -r `pwd` ../xen0

Build_gnbd(){
	cpu_type=$1
	flavor=$2
	kernel_src=/lib/modules/%{kernel_version}$flavor/build
	# Kernel tree setup
	if [ -d $kernel_src/. ]; then
		echo "Kernel %{kernel_version} found."
		echo $kernel_src
	else
		echo "Kernel %{kernel_version} not found."
		echo $kernel_src
		ls /lib/modules/*
		exit 1
	fi
        ./configure --kernel_src=$kernel_src --incdir=%{_includedir}
        if [ "$flavor" == "xenU" -o "$flavor" == "xen0" ]; then
                make ARCH=xen %{?_smp_mflags}
        else
                make %{?_smp_mflags}
        fi
}

%if %{buildup}
Build_gnbd %{_target_cpu}
%endif

%if %{buildsmp}
cd ../smp
Build_gnbd %{_target_cpu} smp
%endif

%if %{buildxen}
cd ../xenU
Build_gnbd %{_target_cpu} xenU

cd ../xen0
Build_gnbd %{_target_cpu} xen0
%endif

################################################################################
##  THE INSTALL SECTION
################################################################################
%install
rm -rf $RPM_BUILD_ROOT

%if %{buildup}
make install DESTDIR=$RPM_BUILD_ROOT
%endif

%if %{buildsmp}
cd ../smp
make install DESTDIR=$RPM_BUILD_ROOT
%endif

%if %{buildxen}
cd ../xenU
make install DESTDIR=$RPM_BUILD_ROOT ARCH=xen
cd ../xen0
make install DESTDIR=$RPM_BUILD_ROOT ARCH=xen
%endif


################################################################################
##  THE CLEAN SECTION
################################################################################
%clean
rm -rf $RPM_BUILD_ROOT

%post
/sbin/depmod -e %{kernel_version}

%if %{buildsmp}
%post smp
/sbin/depmod -e %{kernel_version}smp
%endif

%if %{buildxen}
%post xenU
/sbin/depmod -e %{kernel_version}xenU
%post xen0
/sbin/depmod -a %{kernel_version}xen0
%endif

%files
%defattr(-,root,root,-)
/lib/modules/%{kernel_version}/kernel/drivers/block/gnbd/gnbd.ko

%if %{buildsmp}
%files -n gnbd-kernel-smp
%defattr(-,root,root,-)
/lib/modules/%{kernel_version}smp/kernel/drivers/block/gnbd/gnbd.ko
%endif

%if %{buildxen}
%files -n gnbd-kernel-xenU
%defattr(-,root,root,-)
/lib/modules/%{kernel_version}xenU/kernel/drivers/block/gnbd/gnbd.ko

%files -n gnbd-kernel-xen0
%defattr(-,root,root,-)
/lib/modules/%{kernel_version}xen0/kernel/drivers/block/gnbd/gnbd.ko
%endif

%files -n gnbd-kernheaders
%defattr(-,root,root,-)
%{_includedir}/linux/gnbd.h

%changelog
* Mon May 23 2005 Chris Feist <cfeist@redhat.com>
- Fixed depmod in %post scriptlet to use correct kernel.

* Tue May 17 2005 Chris Feist <cfeist@redhat.com>
- Provides gnbd-kernel-modules & added ARCH=xen to build.

* Mon May 16 2005 Chris Feist <cfeist@redhat.com>
- Add depmod in %post scriplet.

* Fri May 06 2005 Chris Feist <cfeist@redhat.com>
- Cleanup .spec file.  Don't include file globs anymore.

* Fri Apr 29 2005 Chris Feist <cfeist@redhat.com>
- Rebuild for new kernel
- Adding support for i586, xen0 & xenU

* Mon Dec 20 2004 Chris Feist <cfeist@redhat.com>
- Rebuild for new kernel.

* Fri Dec 10 2004 Chris Feist <cfeist@redhat.com>
- Rebuild for new kernel.

* Thu Nov 18 2004 Chris Feist <cfeist@redhat.com>
- various bug fixes (new upstream sources)

* Mon Oct 25 2004 Chris Feist <cfeist@redhat.com>
- various bug fixes (new upstream sources)

* Tue Aug 17 2004 Jon Brassow <jbrassow@redhat.com>
- various bug fixes (new upstream sources)
- building smp modules, but not packaging them (fixed)

* Thu Jun 17 2004 Jon Brassow <jbrassow@redhat.com> 
- Initial build.
